#ifndef __UTIL_H__
#define __UTIL_H__

#include <digitalSTROM/ds.h>
#include <digitalSTROM/ds485.h>

double timestamp(void);
int daemonize(void);
int sscanf_port(const char* str_port);
int service_to_port(const char *service, const char *protocol);
int passivesock(int port, char *protocol, int qlen, int listenGlobal);

int convert_dsuid_to_avahi_format(char *buf, const dsuid_t *id);

int snprintf_peername(char *buf, int len, int fd);
int sprintf_dsuid(char *buf, const dsuid_t *id);
#define DSUID_STR_BUF(buf)  char buf[3 * sizeof(dsuid_t) + 1]

/** scan dsid from parameter to program
 * @param buf  -- string with format "23f232432343.." 24 bytes
 * @param dsid -- output
 * @ret  -- 0 on success
 */
int scanf_dsid(const char *buf, dsid_t *dsid);

/**
 * sprintf_container -- dumps src / dest address, transactionID
 * and first 16 bytes of content
 * @param buf holds result, NULL is valid input see sprintf
 * @param container to be dumped
 * @return the number of bytes written
 * Use CONTAINER_STR_BUF to allocate large enough buffer
 */
int sprintf_container(char *buf, const ds485_container_t *container);
#define CONTAINER_STR_BUF(buf)  char buf[256] /* TODO magic number */

#endif
